/*
* Copyright (c) 2021 PSPACE, inc. KSAN Development Team ksan@pspace.co.kr
* KSAN is a suite of free software: you can redistribute it and/or modify it under the terms of
* the GNU General Public License as published by the Free Software Foundation, either version 
* 3 of the License.  See LICENSE for details
*
* 본 프로그램 및 관련 소스코드, 문서 등 모든 자료는 있는 그대로 제공이 됩니다.
* KSAN 프로젝트의 개발자 및 개발사는 이 프로그램을 사용한 결과에 따른 어떠한 책임도 지지 않습니다.
* KSAN 개발팀은 사전 공지, 허락, 동의 없이 KSAN 개발에 관련된 모든 결과물에 대한 LICENSE 방식을 변경 할 권리가 있습니다.
*/
package com.pspace.ifs.ksan.gw.utils;

import java.io.File;

public class AzuUtils {
    public static String getPath() {
        return AzuConfig.getInstance().getDiskPath() + File.separator + AzuConstants.CONTAINER_DIRECTORY;
    }

    public static String getPath(String path) {
        return AzuConfig.getInstance().getDiskPath() + File.separator + AzuConstants.CONTAINER_DIRECTORY + File.separator + path;
    }

    public static String getPath(String container, String blob) {
        return AzuConfig.getInstance().getDiskPath() + File.separator + AzuConstants.CONTAINER_DIRECTORY + File.separator + container + File.separator + blob;
    }

    public static String getInfoPath() {
        return AzuConfig.getInstance().getDiskPath() + File.separator + AzuConstants.BLOB_INFO_DIRECTORY;
    }

    public static String getInfoPath(String path) {
        return AzuConfig.getInstance().getDiskPath() + File.separator + AzuConstants.BLOB_INFO_DIRECTORY + File.separator + path;
    }

    public static String getInfoPath(String container, String blob) {
        return AzuConfig.getInstance().getDiskPath() + File.separator + AzuConstants.BLOB_INFO_DIRECTORY + File.separator + container + File.separator + blob;
    }

    public static String getBlockPath(String container, String blob, String id) {
        return AzuConfig.getInstance().getDiskPath() + File.separator + AzuConstants.BLOB_BLOCK_DIRECTORY + File.separator + container + File.separator + blob + File.separator + id;
    }
}

